#!/bin/sh
#set -u
#set -x
#set -e

ALL_BLOCKSIZES="16384 8192 4096 2048 1024 512"
ALL_THREADS="001 002 004 008 016 032 064 128"
ALL_MODES="seqrd rndrd seqwr rndwr"
SIZE=20G

# 95% Latency
GREP='percentile'
SED1='s/.*://'

# min Latency
GREP='min:'
SED1='s/.*://'

# average Latency
GREP='avg:'
SED1='s/.*://'

# max Latency
GREP='max:'
SED1='s/.*://'

# IO/s
GREP='Requests/sec'
SED1='s/\..*//'

for MODE in $ALL_MODES; do
	echo
	echo -n "$MODE"
	echo "	1	2	4	8	16	32	64	128"
	for BLOCKSIZE in $ALL_BLOCKSIZES; do
		echo -n "$BLOCKSIZE	"
		for THREADS in $ALL_THREADS; do
			LOGFILE=sysbench-$SIZE-$MODE-b-$BLOCKSIZE-t-$THREADS
			echo -n `grep $GREP $LOGFILE 2>/dev/null| \
				sed $SED1 | \
				sed 's/ *//' | \
				sed 's/\n//'`
			echo -n "	"
		done
		echo
	done
done
